#!/usr/local/bin/perl -w
# T[o̐ݒɍ킹ĉB

#-------------------------------------------------
# W󋵕\
#-------------------------------------------------

use strict;
use Config::Simple;
use DB_File;
use XML::RSS;
use Jcode;
use CGI;
use LWP::Simple;
use HTML::Template;

# ݒt@C̓Ǎ
my $cfg = new Config::Simple('./config.pl');

# f[^x[XJ
my $DIR_TEMP = $cfg->param('GROBAL.DIR_TEMP');
my $dbname =  "$DIR_TEMP/" . $cfg->param('GROBAL.FNAMEDB');
my %db;
tie (%db, 'DB_File', $dbname) || die "$!:$dbname";

my (@sowlist, @sow);
my @sections = $cfg->param('GROBAL.RSS');
foreach (@sections) {
	# RSSt@C̎擾
	if ((!defined($db{$_})) || (time() > $db{$_} + $cfg->param('GROBAL.INTERVALTIME'))) {
		mirror($cfg->param("$_.url"), "$DIR_TEMP/$_.rss");
		$db{$_} = (stat("$DIR_TEMP/$_.rss"))[9];
	}

	# RSSt@C̉
	my $type = $cfg->param("$_.type");
	my $rss;
	if ($type eq 'rss') {
		$rss = new XML::RSS;
		$rss->parsefile("$DIR_TEMP/$_.rss");
	} else {
		$rss = &ParseSummary("$DIR_TEMP/$_.rss")
	}

	# ꗗ
	my @vindex;
	foreach (@{$rss->{'items'}}) {
		my $vname = $_->{'title'};
		&cvtsjis(\$vname) if ($type eq 'rss');
		my %vi = (
			VNAME => $vname,
			LINK  => $_->{'link'},
		);
		push(@vindex, \%vi);
	}

	# 
	my $sowname = substr($rss->{'channel'}->{'title'}, index($rss->{'channel'}->{'title'}, ' - ') + 3);
	&cvtsjis(\$sowname) if ($type eq 'rss');

	# ꗗiڎpj
	my %sowlistsingle = (
		SOWNO    => $_,
		SOWNAME  => $sowname,
	);
	push(@sowlist, \%sowlistsingle);

	# ꗗ
	my %sowsingle = (
		SOWNO    => $_,
		SOWURL   => $rss->{'channel'}->{'link'},
		SOWNAME  => $sowname,
		DESC     => $cfg->param("$_.desc"),
		VINDEX   => \@vindex,
		UPDATEDT => &cvtdt($db{$_}),
	);
	push(@sow, \%sowsingle);
}

# ʂ̏o
my $cgi = new CGI;
my $template = HTML::Template->new(filename => $cfg->param('GROBAL.FNAMETMPL'));

$template->param(
	SOWLIST => \@sowlist,
	SOW     => \@sow,
);

print $cgi->header(
	-charset => 'Shift-JIS',
);
print $template->output();

untie %db;
exit();

#----------------------------------------
# ̕ϊ
#----------------------------------------
sub cvtdt {
	my $dt = shift;

	my ($sec, $min, $hour, $day, $mon, $year, $week, $yday, $summer) = localtime($dt);
	my $result = sprintf("%4d/%02d/%02d(%s) %02d:%02d:%02d",
$year + 1900, ++$mon, $day, ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat')[$week], $hour, $min, $sec);

	return $result;
}

#----------------------------------------
# UTF8SJISւ̕ϊ
#----------------------------------------
sub cvtsjis {
	&Jcode::convert($_[0], 'sjis', 'utf8');
	return;
}

#----------------------------------------
# Summary擾
#----------------------------------------
sub ParseSummary {
	my $filename = shift;
	my %rss;
	my @item;
	my %channel;
	$rss{'channel'} = \%channel;
	$rss{'items'} = \@item;

	open(FILE, $filename) || die "$!:$dbname";
	my $block = '';
	my $n = 0;
	foreach(<FILE>) {
		if ((index($_, '<div class="channel">') >= 0) || (index($_, '<div class="item">') >= 0)) {
			/<[^ ]* class=\"([^"]*)\">/;
			$block = $1;
			if ($block eq 'item') {
				my %itemsingle;
				push(@{$rss{'items'}}, \%itemsingle);
			}
		} elsif (index($_, '</div>') >= 0) {
			$block = '';
		} elsif ($block ne '')  {
			if (/<[^ ]* class=\"([^"]*)\">([^<]*)<\/[^>]*>/) {
				if ($block eq 'channel') {
					$rss{'channel'}->{$1} = $2;
				} else {
					my $item = $rss{'items'};
					$item->[$#$item]->{$1} = $2;
				}
			}
		}	
	}
	close(FILE);

	return \%rss;
}
